//OmbreTexte_518f.js
// 23.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ce script sert  crer une ombre porte derrire un texte

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// mmoriser la surface de travail
var actSpread = app.activeWindow.activeSpread;

// tester la slection
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Il n'a pas de slection.", "Stop");
	exit();
}

// tester le premier lment de la slection avant de montrer le dialogue
if (app.selection[0].constructor.name == "Rectangle") {
	alert ("Il faut slectionner un bloc texte\net relancer le script.", "Stop");
	exit();
}

// appeler la fonction pour lire les prfrences enregistrs
var difPrefs = getPrefs();
var bName = difPrefs[0];
var offVal = difPrefs[1];
var tintVal = difPrefs[2];
// traduire, si ncessaire, les noms des deux couleurs de base
if (bName == "Black") {
	bName = "Noir";
}
else if (bName == "Paper") {
	bName = "Papier";
}
// appeler la fonction qui prpare la liste des couleurs
var colorList = getColorList(bName);
// appeler la fonction qui montre le dialogue
var shadowDef = askUser();
// appeler la fonction qui crit le rsultat dans un fichier
writeResult(shadowDef);
// extraire les lments de la dfinition
var tmpDef = shadowDef.split("\n");
var aColor = tmpDef[0];
var aOffset = tmpDef[1] * 1;
var aTint = tmpDef[2] * 1;
// une boucle de rptition  travers les blocs slectionns
var curType;
for (var i=0; i<nItems; i++) {
	curType = selItems[i].constructor.name;
	checkFrame(i, curType, aColor, aOffset, aTint);
}
// dselectionner les blocs
app.selection = null;

// la fonction qui teste les blocs
function checkFrame(i, curType, aColor, aOffset, aTint) {
	var textFrame;
	var id1;
	var selType;
	var aFlag;
	if (curType != "Group") {
		// appeler la fonction pour examiner le bloc courant
		frameInfo = getFrame(i, curType);
		textFrame = frameInfo[0];
		id1 = frameInfo[1];
		selType = frameInfo[2];
		aFlag = frameInfo[3];
		// appeler la fonction pour dupliquer le bloc
		dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag);
	}
	else {
		var curType;
		curGroup = selItems[i].allPageItems;
		newFrames = selItems[i].ungroup();
		for (k=0; k<curGroup.length; k++) {
			curType = curGroup[k].constructor.name;
			// appeler la fonction pour examiner le bloc courant
			frameInfo = getGroup(k, curGroup, curType);
			textFrame = frameInfo[0];
			id1 = frameInfo[1];
			selType = frameInfo[2];
			aFlag = frameInfo[3];
			// appeler la fonction pour dupliquer le bloc
			dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag);
		}
		
	}
}

// la fonction qui prpare les infos
function getPrefs() {
	var shadowDef = "";
	// lire le fichier contenant les valeurs mmorises
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/ombre.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			shadowDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	
	// extraire les trois valeurs de l'ombre
	if (shadowDef != "") {
		var defVal = shadowDef.split("\n");
		var bName = defVal[0];
		var offVal = defVal[1] * 1;
		var tintVal = defVal[2] * 1;
	}
	else {
		var bName = "Black";
		var offVal = 0.3;
		var tintVal = 100;
	}
	return [bName, offVal, tintVal];
}

// une fonction pour prparer la liste des couleurs
function getColorList(bName) {
	// dfinir une variable avec une rfrence aux couleurs de la palette
	var allSwatches = app.documents[0].swatches;
	
	// tester si la couleur mmoris existe
	if (bName != "Noir" && bName != "Papier") {
		var okay = false;
		try {
			okay = app.documents[0].colors.item(bName).colorValue;
		}
		catch (e) {
		}
		if (okay == false) {
			bName = "Noir";
		}
	}
	
	// assembler la liste des couleurs
	// placer "Noir" comme deuxime lment (s'il n'est pas le premier), 
	// renommer "Paper" en "Papier" et sauter l'lment s'il est 
	// "None", "Black", "Registration" ou la couleur par dfaut (= bName)
	var colorList = new Array();
	colorList[0] = bName;
	if (bName != "Noir") {
		colorList.push("Noir");
	}
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "Paper") {
			cName = "Papier";
		}
		if (cName != bName && cName != "None" && cName != "Black" && cName != "Registration") {
			colorList.push(cName);
		}
	}
	return colorList;
}

function askUser() {
	// effacer des dialogues qui sont ventuellement rests dans la mmoire
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// crer un dialogue
	var aDialog = app.dialogs.add({name:"Ombre texte", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Dcalage:"});
					}
					with (dialogColumns.add()) {
						var shadowOffset = realEditboxes.add({editValue:offVal, minWidth:32});
					}
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"mm", minWidth:26});
					}
				}
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Teinte:"});
					}
					with (dialogColumns.add()) {
						var shadowTint = realEditboxes.add({editValue:tintVal, minimumValue:0, maximumValue:100, minWidth:32});
					}
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"", minWidth:4});
				}
			}
		}
	}
	
	// montrer le dialogue
	if (aDialog.show() == true) {
		var aColor, aOffset, aTint;
		// reprendre les choix de l'utilisateur
		// le nom de la couleur est l'lment 'selectedIndex' de l'array 'colorList'
		aColor = colorList[colorNames.selectedIndex];
		if (aColor == "Noir") {
			aColor = "Black";
		}
		else if (aColor == "Papier") {
			aColor = "Paper";
		}
		// le dcalage de l'ombre
		aOffset = shadowOffset.editValue;
		// la teinte de l'ombre
		aTint = shadowTint.editValue;
		
		// effacer le dialogue de la mmoire
		aDialog.destroy();
		
		var shadowDef = aColor + "\n" + aOffset + "\n" + aTint;
	}
	else {
		aDialog.destroy();
		exit();
	}
	return shadowDef;
}

// crire le rsultat dans un fichier
// la ligne contenant 'encoding' sert  convertir les caractres accentus 
// et autres apostrophes
function writeResult(shadowDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/ombre.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.encoding = "ISO-8851-9" 
			f.write(shadowDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// la fonction qui teste le genre du bloc slectionn
function getFrame(i, curType) {
	// dfinir le genre de bloc texte 
	var selType = 0;
	if (curType == "TextFrame") {
		selType = 1;
		var textFrame = selItems[i];
	}
	else if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" || curType == "Word" 
		|| curType == "Line" || curType == "Paragraph" || curType == "TextStyleRange" || curType == "TextColumn") {
		app.selection = selItems[i].parentTextFrames[0];
		var textFrame = selItems[i].parentTextFrames[0];
		selType = 1;
	}
	else if (curType == "Polygon" || curType == "GraphicLine") {
		var textFrame = selItems[i];
		selType = 2;
	}
	
	// tester si le bloc contient du texte
	var numChars = 0;
	var aFlag = 0;
	if (selType == 1) {
		try {
			numChars = textFrame.texts.item(0).length;
			aFlag = 1;
		}
		catch (e) {
		}
		if (numChars == 0) {
			try {
				var aTextPath = textFrame.textPaths.length;
				if (aTextPath == 1) {
					numChars = textFrame.textPaths.item(0).texts.item(0).length;
					aFlag = 2;
				}
			}
			catch (e) {
			}
		}
	}
	else if (selType == 2) {
		try {
			numChars = textFrame.textPaths.item(0).texts.item(0).length;
			aFlag = 2;
		}
		catch (e) {
		}
	}
	else if (selType == 0) {
		alert ("Il faut slectionner un bloc texte.");
		exit();
	}
	
	if (numChars == 0) {
		alert ("Le bloc slectionn ne contient pas de texte.");
		exit();
	}
	// mmoriser le 'id' du bloc slectionn
	id1 = textFrame.id;
	return [textFrame, id1, selType, aFlag];
}

function getGroup(k, curGroup, curType) {
	var selType = 0;
	if (curType == "TextFrame") {
		selType = 1;
		var textFrame = curGroup[k];
	}
	else if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" || curType == "Word" 
		|| curType == "Line" || curType == "Paragraph" || curType == "TextStyleRange" || curType == "TextColumn") {
		app.selection = curGroup[k].parentTextFrames[0];
		var textFrame = curGroup[k];
		selType = 1;
	}
	else if (curType == "Polygon" || curType == "GraphicLine") {
		var textFrame = curGroup[k];
		selType = 2;
	}
	
	// tester si le bloc contient du texte
	var numChars = 0;
	var aFlag = 0;
	if (selType == 1) {
		try {
			numChars = textFrame.texts.item(0).length;
			aFlag = 1;
		}
		catch (e) {
		}
		if (numChars == 0) {
			try {
				var aTextPath = textFrame.textPaths.length;
				if (aTextPath == 1) {
					numChars = textFrame.textPaths.item(0).texts.item(0).length;
					aFlag = 2;
				}
			}
			catch (e) {
			}
		}
	}
	else if (selType == 2) {
		try {
			numChars = textFrame.textPaths.item(0).texts.item(0).length;
			aFlag = 2;
		}
		catch (e) {
		}
	}
	else if (selType == 0) {
		alert ("Il faut slectionner un bloc texte.");
		exit();
	}
	
	if (numChars == 0) {
		alert ("Le bloc slectionn ne contient pas de texte.");
		exit();
	}
	// mmoriser le 'id' du bloc slectionn
	id1 = textFrame.id;
	return [textFrame, id1, selType, aFlag];
}

// dupliquer le bloc texte 
function dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag) {
	var shadowBox = textFrame.duplicate();
	// passer la copie derrire le bloc original
	shadowBox.sendBackward();
	// calculer la nouvelle position avec la fonction "getBounds"
	shadowBox.geometricBounds = getBounds(shadowBox, aOffset);
	// appliquer la couleur choisie et la teinte dsire
	if (aFlag == 1) {
		shadowBox.texts.item(0).fillColor = aColor;
		shadowBox.texts.item(0).fillTint = aTint;
	}
	else if (aFlag == 2) {
		shadowBox.textPaths.item(0).texts.item(0).fillColor = aColor;
		shadowBox.textPaths.item(0).texts.item(0).fillTint = aTint;
	}
}

// supprimer des signes invisibles  la fin du texte "ombre" (retour, nouvelle ligne, 
// saut de colonne, saut de bloc, saut de page, saut de page impaire, saut de page paire)
try {
	var cleanUp = true;
	while (cleanUp == true) {
		lastChar = shadowBox.parentStory.paragraphs[-1].characters[-1].contents;
		if (lastChar == "\r" || lastChar == "\n" || lastChar == 1396927554 || lastChar == 1397125698 
		|| lastChar == 1397778242 || lastChar == 1397715010 || lastChar == 1397059650) {
			shadowBox.parentStory.paragraphs[-1].characters[-1].remove();
		}
		else {
			cleanUp = false;
		}
	}
}
catch (e) {
}

// fonction utilise pour calculer la nouvelle position du bloc "ombre"
function getBounds(shadowBox, aOffset) {
	var y1, x1, y2, x2;
	y1 = shadowBox.geometricBounds[0] + aOffset;
	x1 = shadowBox.geometricBounds[1] + aOffset;
	y2 = shadowBox.geometricBounds[2] + aOffset;
	x2 = shadowBox.geometricBounds[3] + aOffset;
	return [y1, x1, y2, x2];
}